#include "stdafx.h"
#include "ImageWnd.h"

using namespace std;

IMPLEMENT_DYNAMIC(CImageWnd, CWnd)

CImageWnd::CImageWnd()
: m_colorIndex(0)
{
}

CImageWnd::~CImageWnd()
{
}

BEGIN_MESSAGE_MAP(CImageWnd, CWnd)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

BOOL CImageWnd::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext /* = NULL */)
{
	// Register the window class.
	TRACE("CS_SAVEBITS set for CImageWnd...\n");
	CString wndClass = ::AfxRegisterWndClass(CS_SAVEBITS, AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	
	// Call the base class for creation.
	return CWnd::CreateEx(NULL, wndClass, NULL, dwStyle, rect, pParentWnd, nID, pContext);
}

// CReplayWnd message handlers

BOOL CImageWnd::OnEraseBkgnd(CDC* /*pDC*/)
{
	return TRUE;
}

void CImageWnd::OnPaint()
{
	CPaintDC dc(this);
	CXTPClientRect rClient(this);
	CXTMemDC memDC(&dc, rClient, RGB(128, 128, 128));
	
	const int NUM = 7;
	const COLORREF colors[NUM] = 
	{
		RGB(0, 0, 0),
		RGB(255, 0, 0),
		RGB(0, 255, 0),
		RGB(0, 0, 255),
		RGB(255, 255, 0),
		RGB(0, 255, 255),
		RGB(255, 255, 255)
	};
	
	// Example of heavy drawing, which makes things worse!
	COLORREF color = colors[m_colorIndex];
	for (int x = 0; x < rClient.Width(); ++x)
	{
		for (int y = 0; y < rClient.Height(); ++y)
			memDC.SetPixel(x, y, color);
	}

	m_colorIndex = (m_colorIndex + 1) % NUM;
}
